
#ifndef _TYPES_H_
#define _TYPES_H_



//------------------------------------------------------------------------------
//  ⺻ Ÿ Ÿ
//------------------------------------------------------------------------------
typedef signed char        S8, s8;      
typedef unsigned char      U8, u8, byte;

typedef signed short       S16, s16;     
typedef unsigned short     U16, u16;     

typedef signed int         S32, s32;     
typedef unsigned int       U32, u32;     

typedef signed __int64		S64, s64;
typedef unsigned __int64	U64, u64;

typedef float              F32, f32;     
typedef double             F64, f64;     

typedef const char *stringc;


//------------------------------------------------------------------------------
//  Multi byte character
//------------------------------------------------------------------------------
union mchar 
{
	struct { U8 c1, c2; };
	U8	ch[2];
	U16  sh;
};


//------------------------------------------------------------------------------
//  Memory  Macro
//------------------------------------------------------------------------------
#define safe_delete(p)       { if(p) { delete (p);     (p)=NULL; } }
#define safe_delete_array(p) { if(p) { delete[] (p);   (p)=NULL; } }
#define safe_release(p)      { if(p) { (p)->Release(); (p)=NULL; } }


//--------------------------------------
//	NULL
//--------------------------------------
#ifndef NULL
#  define NULL 0
#endif


//--------------------------------------
// MIN
//--------------------------------------
#define DECLARE_MIN_FUNC(type)		\
inline type getMin(type a, type b)	\
{									\
   return a>b ? b : a;				\
}

DECLARE_MIN_FUNC(U32)
DECLARE_MIN_FUNC(S32)
DECLARE_MIN_FUNC(U16)
DECLARE_MIN_FUNC(S16)
DECLARE_MIN_FUNC(U8)
DECLARE_MIN_FUNC(S8)
DECLARE_MIN_FUNC(float)
DECLARE_MIN_FUNC(double)


//--------------------------------------
// MAX
//--------------------------------------
#define DECLARE_MAX_FUNC(type)		\
inline type getMax(type a, type b)	\
{									\
	return a>b ? a : b;				\
}

DECLARE_MAX_FUNC(u32)
DECLARE_MAX_FUNC(s32)
DECLARE_MAX_FUNC(u16)
DECLARE_MAX_FUNC(s16)
DECLARE_MAX_FUNC(u8)
DECLARE_MAX_FUNC(s8)
DECLARE_MAX_FUNC(float)
DECLARE_MAX_FUNC(double)


//--------------------------------------
// bit enum macro
//--------------------------------------
#define BIT(x) (1 << (x))        


//--------------------------------------
// ҹ, 빮 ȯ Լ
//--------------------------------------
inline char toUpper(const char c) 
{ 
	if (c >= 'a' && c <= 'z') 
		return (c + 'A' - 'a'); 
	else 
		return c; 
}

inline char toLower(const char c) 
{ 
	if (c >= 'A' && c <= 'Z') 
		return (c - 'A' + 'a'); 
	else 
		return c; 
}


#endif 
